<?php
/*---------------------------------------------------+
| PHP-Fusion 6 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2005 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------*/
require_once "../../maincore.php";
require_once BASEDIR."subheader.php";
require_once ADMIN."navigation.php";

if (!checkrights("IP")) fallback("../index.php");
if (isset($track_id) && !isNum($track_id)) fallback(FUSION_SELF);
if (isset($track_order) && !isNum($track_order)) fallback(FUSION_SELF);

if (file_exists(INFUSIONS."musicbox2_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."musicbox2_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."musicbox2_panel/locale/English.php";
}

if (isset($_POST['save'])){
	$track_title = preg_replace("/\s+/", " ", str_replace(array("_", "+")," ",stripinput($_POST['track_title'])));
	$track_path = stripinput(urldecode($_POST['track_path']));
	
	if (!$track_title) {
		$track_title = strrchr($track_path,"/");
		$length = strrpos($track_title,".");
		$length = (!$length ? strlen($track_title) : $length)-1;
		$track_title = substr($track_title,1,$length);
	}
	
	if (isset($track_id)){
		dbquery("UPDATE ".$db_prefix."musicbox2 SET track_title='".$track_title."', track_path='".$track_path."' WHERE track_id='".$track_id."'");
	} else {
		echo $track_order = dbresult(dbquery("SELECT max(track_order) FROM ".$db_prefix."musicbox2"),0)+1;
		dbquery("INSERT INTO ".$db_prefix."musicbox2 (track_title,track_path,track_order) VALUES ('".$track_title."','".$track_path."','".$track_order."')");
	}
	
	fallback(FUSION_SELF);
} elseif ($_POST['cancel']) {
	fallback(FUSION_SELF);
} elseif ($step == "delete") {
	$data = dbarray(dbquery("SELECT track_order FROM ".$db_prefix."musicbox2 WHERE track_id='".$track_id."'"));
	$result = dbquery("DELETE FROM ".$db_prefix."musicbox2 WHERE track_id='".$track_id."'");
	$result = dbquery("UPDATE ".$db_prefix."musicbox2 SET track_order=track_order-1 WHERE track_order>='".$data['track_order']."'");
	fallback(FUSION_SELF);
} elseif ($step == "mup") {
	$data = dbarray(dbquery("SELECT track_id FROM ".$db_prefix."musicbox2 WHERE track_order='".$track_order."'"));
	$result = dbquery("UPDATE ".$db_prefix."musicbox2 SET track_order=track_order+1 WHERE track_id='".$data['track_id']."'");
	$result = dbquery("UPDATE ".$db_prefix."musicbox2 SET track_order=track_order-1 WHERE track_id='".$track_id."'");
	fallback(FUSION_SELF);
} elseif ($step == "mdown") {
	$data = dbarray(dbquery("SELECT track_id FROM ".$db_prefix."musicbox2 WHERE track_order='".$track_order."'"));
	$result = dbquery("UPDATE ".$db_prefix."musicbox2 SET track_order=track_order-1 WHERE track_id='".$data['track_id']."'");
	$result = dbquery("UPDATE ".$db_prefix."musicbox2 SET track_order=track_order+1 WHERE track_id='".$track_id."'");
	fallback(FUSION_SELF);
} elseif ($step == "status") {
	$data = dbarray(dbquery("SELECT track_id,track_status FROM ".$db_prefix."musicbox2 WHERE track_id='".$track_id."'"));
	$result = dbquery("UPDATE ".$db_prefix."musicbox2 SET track_status=".($data['track_status']==1?0:1)." WHERE track_id='".$data['track_id']."'");
	fallback(FUSION_SELF."?refreshed");
} elseif ($step == "refresh") {
	$result = dbquery("SELECT track_id FROM ".$db_prefix."musicbox2 ORDER BY track_order ASC, track_title ASC");
	if (dbrows($result)){
		$i = 1;
		while($data = dbarray($result)) {
			dbquery("UPDATE ".$db_prefix."musicbox2 SET track_order='".$i."' WHERE track_id = '".$data['track_id']."'");
			$i++;
		}
	}
	fallback(FUSION_SELF);
} elseif ($step == "create") {
	opentable($locale['mb_218']);
	$result = @dbquery("SELECT * FROM ".$db_prefix."musicbox2 WHERE track_status='1' ORDER BY track_order ASC");
	echo "<div style='margin-bottom:10px;'>".$locale['mb_220']."</div>\n";
	echo "<textarea class='textbox' style='width:95%; height:300px; font-family:monospace'>\n";
	if (@dbrows($result)){
		echo "&lt;?xml version='1.0' encoding='UTF-8'?&gt;\n&lt;xml&gt;\n";
		while ($data = dbarray($result)){
			echo "   &lt;track&gt;\n";
			echo "      &lt;path&gt;".$data['track_path']."&lt;/path&gt;\n";
			echo "      &lt;title&gt;".$data['track_title']."&lt;/title&gt;\n";
			echo "   &lt;/track&gt;\n";
		}
		echo "&lt;/xml&gt;\n";
	} else {
		echo $locale['mb_221'];
	}
	echo "</textarea>\n<br>\n";
	echo "<div style='margin: 10px auto;'>".sprintf($locale['mb_222'],"<i class='alt'>musicbox2_panel/player/playlist.xml</i>","<i class='alt'>musicbox2_panel/player/index.html</i>","<i style='color:red'>playlist.php</i>", "<i style='color:green'>playlist.xml</i>")."</div>\n";
	echo "<div class='quote' style='margin-left: 0;width:95%;white-space:nowrap;overflow:auto'><code style='white-space:nowrap'>&lt;param name='flashvars' value='playlistPath=<b style='color:red'>playlist.php</b>&amp;amp;autoPlay=yes'&gt;<br>&lt;param name='flashvars' value='playlistPath=<b style='color:green'>playlist.xml</b>&amp;amp;autoPlay=yes'&gt;<br><br><br></code></div>\n";
	echo "<div style='margin-top:10px; text-align:center'>[<a href='".FUSION_SELF."'>".$locale['mb_223']."</a>]</div>\n";
	closetable();
	
} else {
	if (!file_exists(INFUSIONS."musicbox2_panel/player/playerMultipleList.swf")){
		opentable("".$locale['mb_224']."");
		echo "<p style='text-align:center;color:#F00000; font-weight:bold;'>".sprintf($locale['mb_225'], "( <span style='font-style:italic;'>playerMultipleMenu.swf</span> )")."</p>\n";
		closetable();
	} else {
		if ($step == "edit"){
			$result = dbquery("SELECT * FROM ".$db_prefix."musicbox2 WHERE track_id = '".$track_id."'");
			if (!@dbrows($result)) fallback(FUSION_SELF);
			$data = dbarray($result);
			$track_title = $data['track_title'];
			$track_path = $data['track_path'];
			$formaction = FUSION_SELF."&amp;track_id=".$data['track_id'];
			opentable($locale['mb_201']);
		} else {
			$track_title = "";
			$track_path = "";
			$formaction = FUSION_SELF;
			opentable($locale['mb_200']);
		}
		echo "<form action='".$formaction."' method='post'>
<table cellpadding='0' cellspacing='0' align='center'>
<tr>
<td class='tbl'>".$locale['mb_202'].":</td>
<td class='tbl'><input type='text' name='track_title' value='".$track_title."' maxlength='100' class='textbox' style='width:450px'></td>
</tr>
<tr>
<td class='tbl'>".$locale['mb_203'].":</td>
<td class='tbl'><input type='text' name='track_path' value='".$track_path."' maxlength='255' class='textbox' style='width:450px'></td>
</tr>
<tr>
<td class='tbl' style='text-align:center;' colspan='2'><input type='submit' name='save' value='".$locale['mb_204']."' class='button'> <input type='submit' name='cancel' value='".$locale['mb_205']."' class='button'></td>
</tr>
</table>
</form>\n";
		closetable();
		
		tablebreak();
		
		opentable($locale['mb_206']);
		$result = dbquery("SELECT * FROM ".$db_prefix."musicbox2 ORDER BY track_order ASC");
		if (!($rows=@dbrows($result))) {
			echo "<center>".$locale['mb_207']."</center>\n";
		} else {
			$testPlayerExists = !file_exists(INFUSIONS."musicbox2_panel/player/playerMini.swf");
			$counter = 1;
			$activeSongs = 0;
			echo "<table cellpadding='0' cellspacing='1' class='tbl-border' width='100%'>
<tr>
<td class='tbl' style='text-align:center; font-weight:bold;' width='1%'>#</td>
<td class='tbl' style='text-align:center; font-weight:bold;'>".$locale['mb_202']." / ".$locale['mb_203']."</td>
<td class='tbl' style='text-align:center; font-weight:bold;' colspan='3'>".$locale['mb_208']."</td>
<td class='tbl' style='text-align:center; font-weight:bold;' width='1%'>".$locale['mb_209']."</td>
</tr>\n";
			while ($data = dbarray($result)){
				if ($counter != $data['track_order']) fallback(FUSION_SELF."&step=refresh");
				if ($rows > 1) {
					$up = $data['track_order'] - 1;
					$down = $data['track_order'] + 1;
					if ($counter == 1) {
						$up_down = " <a href='".FUSION_SELF."&amp;step=mdown&amp;track_id=".$data['track_id']."&amp;track_order=".$down."'><img src='images/down.png' alt='&darr;' title='".$locale['mb_210']."' style='border:0px; width:12px; height:12px;'></a>";
					} else if ($counter < $rows) {
						$up_down = " <a href='".FUSION_SELF."&amp;step=mup&amp;track_id=".$data['track_id']."&amp;track_order=".$up."'><img src='images/up.png' alt='&uarr;' title='".$locale['mb_211']."' style='border:0px; width:12px; height:12px;'></a>\n";
						$up_down .= " <a href='".FUSION_SELF."&amp;step=mdown&amp;track_id=".$data['track_id']."&amp;track_order=".$down."'><img src='images/down.png' alt='&darr;' title='".$locale['mb_210']."' style='border:0px; width:12px; height:12px;'></a>";
					} else {
						$up_down = " <a href='".FUSION_SELF."&amp;step=mup&amp;track_id=".$data['track_id']."&amp;track_order=".$up."'><img src='images/up.png' alt='&uarr;' title='".$locale['mb_211']."' style='border:0px; width:12px; height:12px;'></a>";
					}
				} else {
					$up_down = "";
				}
				if ($data['track_status']==1) $activeSongs++;
				$flag = ($counter%2 ? "tbl2" : "tbl1");
				echo "<tr>
<td class='$flag' style='text-align:center' rowspan='2'>".$counter."</td>
<td class='$flag'><a style='font-weight:bold; color:".(!$data['track_status'] ? "#C60000" : "#008000")."' href='".FUSION_SELF."?&amp;step=status&amp;track_id=".$data['track_id']."' title='".$locale['mb_212']."'>".trimlink($data['track_title'],50)."</a></td>
<td class='$flag' rowspan='2' width='1%'><a href='".FUSION_SELF."&amp;step=edit&amp;track_id=".$data['track_id']."'><img src='images/edit.png' alt='E' title='".$locale['mb_213']."' style='border:0px; width:14px; height:14px;'></a></td>
<td class='$flag' rowspan='2' width='1%'><a href='".FUSION_SELF."&amp;step=delete&amp;track_id=".$data['track_id']."' onClick='return DeleteTrack()'><img src='images/delete.png' alt='D' title='".$locale['mb_214']."' style='border:0px; width:12px; height:12px;'></a></td>
<td class='$flag' rowspan='2' width='1%' style='text-align:center' nowrap>".$up_down."</td>
<td class='$flag' rowspan='2' width='1%' style='text-align:center'>".($testPlayerExists ? $locale['mb_215'] : "<object data='player/playerMini.swf' type='application/x-shockwave-flash' width='75' height='30'><param name='movie' value='player/playerMini.swf'><param name='menu' value='false'><param name='scale' value='noscale'><param name='flashvars' value='playlistPath=playlist.php&amp;autoPlay=no&amp;overColor=#".dechex(rand(255,16777215))."&amp;soundPath=".$data['track_path']."'></object>")."</td>
</tr><tr><td class='$flag'><a href='".str_replace(" ", "%20", $data['track_path'])."' target='_blank'>".(strlen($data['track_path']) > 80 ? "... ".substr($data['track_path'],-50) : $data['track_path'])."</a></td>
</tr>\n";
				$counter++;
			}
			echo "</table>\n";
			echo "<div style='text-align:center; margin-top:15px; color:#A00;'>".($activeSongs > 0 ? "<button class='button' onclick='openMusicBoxTest()'>".$locale['mb_216']."</button>": "<b>".$locale['mb_217']."</b>")."</div>\n";
		}
		closetable();
		echo "<div style='text-align:right; font-size:9px'>[<a href='".FUSION_SELF."&amp;step=create'>".$locale['mb_218']."</a>]</div>\n";
	}
}

echo "<script type='text/javascript' language='JavaScript'>
<!--
function DeleteTrack() {
	return confirm('".$locale['mb_219']."');
}
function openMusicBoxTest(){
	window.open('".INFUSIONS."musicbox2_panel/player/','MusicBoxFlashPlayerTest','width=300,height=300,top=30,left=30,menubar=no,toolbar=no,location=no,directories=no,status=no,scrollbars=no,resizable=no,fullscreen=no,channelmode=no').focus();
}
//-->
</script>
</td>\n";
require_once BASEDIR."footer.php";
?>
